# Class: YARD::Handlers::Ruby::ExceptionHandler

Inherits:
  Base
  - Object
  - Base
  - Base
  - YARD::Handlers::Ruby::ExceptionHandler
  show all

Defined in:
  lib/yard/handlers/ruby/exception_handler.rb

## Overview

Handles ‘raise’ calls inside methods

## Constant Summary

### Constants included from CodeObjects

CodeObjects::BUILTIN_ALL, CodeObjects::BUILTIN_CLASSES, CodeObjects::BUILTIN_EXCEPTIONS, CodeObjects::BUILTIN_EXCEPTIONS_HASH, CodeObjects::BUILTIN_MODULES, CodeObjects::CONSTANTMATCH, CodeObjects::CONSTANTSTART, CodeObjects::CSEP, CodeObjects::CSEPQ, CodeObjects::ISEP, CodeObjects::ISEPQ, CodeObjects::METHODMATCH, CodeObjects::METHODNAMEMATCH, CodeObjects::NAMESPACEMATCH, CodeObjects::NSEP, CodeObjects::NSEPQ

## Instance Method Summary collapse

- #process ⇒ void

  Main processing callback.

### Methods included from Parser::Ruby

#s

### Methods included from CodeObjects::NamespaceMapper

#clear_separators, #default_separator, on_invalidate, #register_separator, #separators, #separators_for_type, #separators_match, #types_for_separator, #unregister_separator_by_type

## Constructor Details

This class inherits a constructor from YARD::Handlers::Base

## Instance Method Details

### #process ⇒ `void`

This method returns an undefined value.

Main processing callback

    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26

    # File 'lib/yard/handlers/ruby/exception_handler.rb', line 6

    process do
      return unless owner.is_a?(MethodObject) # Only methods yield
      return if [:command_call, :call].include? statement.type
      return if owner.has_tag?(:raise)

      klass = nil
      if statement.call?
        params = statement.parameters(false)
        if params.size == 1
          if params.first.ref? && params.first.first.type != :ident
            klass = params.first.source
          elsif params.first.call? && params.first.method_name(true) == :new
            klass = params.first.namespace.source
          end
        elsif params.size > 1
          klass = params.first.source
        end
      end

      owner.add_tag YARD::Tags::Tag.new(:raise, '', klass) if klass
    end